<style lang="scss">

@import "~assets/mixins";

pre.vue-prism code {
  display: block;
  
  white-space: pre-wrap;
  word-wrap: break-word;
  word-break: break-all;
  
  .line {
    display: inline-block;
    padding-left: $grid;
    text-indent: -$grid;
  }
}

</style>
<script>

function assign(obj) {
  for (let i = 1; i < arguments.length; i++) {
    // eslint-disable-next-line guard-for-in, prefer-rest-params
    for (const p in arguments[i]) obj[p] = arguments[i][p]
  }
  return obj
}

import Prism from 'prismjs'

export default {
  props: {
    code: {
      type: String
    },
    language: {
      type: String,
      default: 'javascript',
    }
  },
  render(h) {
    var text;

    try {
      text = this.$slots.default && this.$slots.default[0].text;
      
      if(!text) {
        var v = this.$slots.default[0]
        if(v.tag == 'pre') {
          text = v.children && v.children[0].children[0].text;
        }
      }
    } catch(x) {
      
    }
    
    text = text || 'invalid code block - try indenting with 4 spaces'
    
    const code = this.code || text.match(/^\s*([^]*?)\s*$/)[1];
    const language = this.language
    
    const prismLanguage = Prism.languages[language]
    const className = `language-${language}`

    if (process.env.NODE_ENV === 'development' && !prismLanguage) {
      throw new Error(
        `Prism component for language "${language}" was not found, did you forget to register it? See all available ones: https://cdn.jsdelivr.net/npm/prismjs/components/`
      )
    }

    var highlit = Prism.highlight(code, prismLanguage);

    highlit = highlit.split('\n').map(s => `<div class="line">${s}</div>`).join('\n');
    
    return h(
      'pre',
      assign({}, this.$attrs, {
        class: [this.$attrs.class, className, 'vue-prism']
      }),
      [
        h('code', {
          class: className,
          domProps: {
            innerHTML: highlit,
          }
        })
      ]
    )
  }
}

</script>
